from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

#TODO: Change the Holder to a RectBeam

# ESP32 STACK HOLDER specify in dimensions.py if different number of stacks
# This is for 3 stacks
c = Component()

c.addParameter("length", 60, paramType="length")
c.addParameter("brains", "esp32stack", paramType="dimension") #change in dimensions.py
c.addParameter("heightChanger", 0, paramType="length")

#Cover/body of the car (I needed one that folds -90; will try on SimpleRectBeam)
c.addSubcomponent("cover", "SimpleRectBeam")
c.addConstraint(("cover", "length"), "length")
c.addConstraint(("cover", "width"), "brains", '(getDim(x, "width"))')
c.addConstraint(("cover", "depth"), "brains", '(getDim(x, "height"))')

# Putting the pins of the ESP32 Stack
c.addSubcomponent("header", "Header")
c.addConstraint(("header", "nrows"), "brains", "getDim(x, 'nrows')")
c.addConstraint(("header", "ncols"), "brains", "getDim(x, 'ncols')")
c.addConstraint(("header", "rowsep"), "brains", "getDim(x, 'rowsep')")
c.addConstraint(("header", "colsep"), "brains", "getDim(x, 'colsep')")

c.addConnection(("cover", "face0"),
                ("header", "decoration"),
                mode="hole", offset=Function(params=("length", "brains"), fnstring="(0, 0)"))

c.addConnection(("cover", "face2"),
                ("header", "decoration"),
                mode="hole", offset=Function(params=("length", "brains"), fnstring="(0, 0)"))

# Holes for servo and power supply
c.addParameter("dy", 18, parameterType="length")

for i in range(2):
    c.addSubcomponent("accessoryHole%d" %i, "Cutout")
    c.addConstraint(("accessoryHole%d" %i, "dy"), "brains", "getDim(x, 'height')/1.75")
    c.addConstraint(("accessoryHole%d" %i, "dx"), "dy", "x-3")

c.addConnection(("cover", "face1"),
                ("accessoryHole0", "decoration"),
                mode="hole", rotate=True,
                offset=Function(params=("brains", "length"), fnstring="(getDim(x[0], 'height') * 0.15, x[1] * 0.25)"))

c.addConnection(("cover", "face3"),
                ("accessoryHole1", "decoration"),
                mode="hole", rotate=True,
                offset=Function(params=("brains", "length"), fnstring="(getDim(x[0], 'height') * -0.15, -x[1] * 0.25)"))

c.inheritAllInterfaces("cover")

c.toLibrary("ESP32Stack")