from rocolib.api.components.Component import Component

c = Component()

c.addParameter("length", 76, paramType="length", minValue=65) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue

c.addSubcomponent("servo", "MountedServo", inherit="angle")
c.addParameter("driveservo", "pivotservo", paramType="dimension")
c.addConstraint(("servo", "servo"), "driveservo")
c.addConstraint(("servo", "length"), "driveservo", 'getDim(x, "motorlength") + 2 * getDim(x, "shoulderlength")')
c.addConstConstraint(("servo", "center"), False)

for i in range(7):
    c.addSubcomponent("belt%d" %i, "Rectangle")
    c.addConstraint(("belt%d"%i, "w"), "driveservo", 'getDim(x, "motorheight")')

for i in range(3):
    c.addConstraint(("belt%d"%i, "l"), ("width", "driveservo"), "(x[0]-getDim(x[1], 'motorwidth'))/2")

for i in range(3, 5):
    c.addConstraint(("belt%d" % i, "l"), "driveservo", 'getDim(x, "motorlength") + 2 * getDim(x, "shoulderlength")')

for i in range(5, 7):
    c.addConstraint(("belt%d"%i, "l"), "length")

c.addConnection(("servo", "botedge3"), ("belt0", "l"), angle=-90)
c.addConnection(("servo", "botedge1"), ("belt1", "l"), angle=-90)
c.addConnection(("servo", "topedge1"), ("belt3", "l"), angle=-180)
c.addConnection(("servo", "topedge3"), ("belt4", "l"), angle=-180)
c.addConnection(("belt2", "l"), ("belt4", "r"), angle=90)

c.addConnection(("belt0", "r"), ("belt5", "l"), angle=90)
c.addConnection(("belt1", "r"), ("belt6", "l"), angle=90)

c.addSubcomponent("pivotface", "Trapezoid")
c.addConstraint(("pivotface", "width"), "width", "x-(2*x*.15)")
c.addConstraint(("pivotface", "depth"), "driveservo", "getDim(x, 'motorlength')")
c.addConstraint(("pivotface", "bangle"), ("width", "driveservo"),
                    "float(np.atan(getDim(x[1], 'motorlength')/(x[0]*.15))* 180 * 0.318309)")

c.addConnection(("servo", "mount"), ("pivotface", "face0"))

c.inheritAllInterfaces("servo")
c.inheritAllInterfaces("pivotface")
for i in range(3):
    c.inheritAllInterfaces("belt%d" %i)

c.toLibrary("Pivot")