from rocolib.api.components.Component import Component

c = Component()

c.addSubcomponent("seat","ChairSeat", inherit=True, prefix=None, root=True)
c.addSubcomponent("legl","RockerLeg", inherit=True, prefix=None)
c.addSubcomponent("legr","RockerLeg", inherit=True, prefix=None)
c.addSubcomponent("crossbar","Rectangle")

c.delParameter("flip")

c.addConstConstraint(("legl","flip"), True)
c.addConstConstraint(("legr","flip"), False)

c.addConstraint(("crossbar","l"), "width")
c.addConstraint(("crossbar","w"), ("height", "rocker"), "x[0] * np.sin(np.deg2rad(x[1]))")

c.addConnection(("seat","left"),("legl","topedge"), angle=0)
c.addConnection(("seat","right"),("legr","topedge"), angle=0)

c.addConnection(("crossbar","l"),("legl","crossbarflip"), angle=90)
c.addConnection(("crossbar","r"),("legr","crossbar"), angle=90)

c.toLibrary("RockerChair")
